systest jenkins pipeline
[osm/devops.git] / installers / install_osm.sh
1 #!/bin/bash
2 # Copyright 2016 Telefónica Investigación y Desarrollo S.A.U.
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 function usage(){
17 echo -e "usage: $0 [OPTIONS]"
18 echo -e "Install OSM from binaries or source code (by default, from binaries)"
19 echo -e " OPTIONS"
20 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
21 echo -e " --source: install OSM from source code using the latest stable tag"
22 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
23 echo -e " -b master (main dev branch)"
24 echo -e " -b v2.0 (v2.0 branch)"
25 echo -e " -b tags/v1.1.0 (a specific tag)"
26 echo -e " ..."
27 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
28 echo -e " --nat: install only NAT rules"
29 # echo -e " --update: update to the latest stable release or to the latest commit if using a specific branch"
30 echo -e " --showopts: print chosen options and exit (only for debugging)"
31 echo -e " -y: do not prompt for confirmation, assumes yes"
32 echo -e " -h / --help: print this help"
33 }
34
35 #Uninstall OSM: remove containers
36 function uninstall(){
37 echo -e "\nUninstalling OSM"
38 if [ $RC_CLONE ] || [ -n "$TEST_INSTALLER" ]; then
39 $OSM_DEVOPS/jenkins/host/clean_container RO
40 $OSM_DEVOPS/jenkins/host/clean_container VCA
41 $OSM_DEVOPS/jenkins/host/clean_container SO
42 #$OSM_DEVOPS/jenkins/host/clean_container UI
43 else
44 lxc stop RO && lxc delete RO
45 lxc stop VCA && lxc delete VCA
46 lxc stop SO-ub && lxc delete SO-ub
47 fi
48 }
49
50 #Configure NAT rules, based on the current IP addresses of containers
51 function nat(){
52 echo -e "\nChecking required packages: iptables-persistent"
53 dpkg -l iptables-persistent &>/dev/null || ! echo -e " Not installed.\nInstalling iptables-persistent requires root privileges" || \
54 sudo DEBIAN_FRONTEND=noninteractive apt-get -yq install iptables-persistent
55 echo -e "\nConfiguring NAT rules"
56 echo -e " Required root privileges"
57 sudo $OSM_DEVOPS/installers/nat_osm
58 }
59
60 #Update RO, SO and UI:
61 function update(){
62 echo -e "\nUpdating components"
63
64 echo -e " Updating RO"
65 CONTAINER="RO"
66 MDG="RO"
67 INSTALL_FOLDER="/opt/openmano"
68 echo -e " Fetching the repo"
69 lxc exec $CONTAINER -- git -C $INSTALL_FOLDER fetch --all
70 BRANCH=""
71 BRANCH=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER status -sb | head -n1 | sed -n 's/^## \(.*\).*/\1/p'|awk '{print $1}' |sed 's/\(.*\)\.\.\..*/\1/'`
72 [ -z "$BRANCH" ] && FATAL "Could not find the current branch in use in the '$MDG'"
73 CURRENT=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER status |head -n1`
74 CURRENT_COMMIT_ID=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER rev-parse HEAD`
75 echo " FROM: $CURRENT ($CURRENT_COMMIT_ID)"
76 # COMMIT_ID either was previously set with -b option, or is an empty string
77 CHECKOUT_ID=$COMMIT_ID
78 [ -z "$CHECKOUT_ID" ] && [ "$BRANCH" == "HEAD" ] && CHECKOUT_ID="tags/$LATEST_STABLE_DEVOPS"
79 [ -z "$CHECKOUT_ID" ] && [ "$BRANCH" != "HEAD" ] && CHECKOUT_ID="$BRANCH"
80 if [[ $CHECKOUT_ID == "tags/"* ]]; then
81 REMOTE_COMMIT_ID=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER rev-list -n 1 $CHECKOUT_ID`
82 else
83 REMOTE_COMMIT_ID=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER rev-parse origin/$CHECKOUT_ID`
84 fi
85 echo " TO: $CHECKOUT_ID ($REMOTE_COMMIT_ID)"
86 if [ "$CURRENT_COMMIT_ID" == "$REMOTE_COMMIT_ID" ]; then
87 echo " Nothing to be done."
88 else
89 echo " Update required."
90 lxc exec $CONTAINER -- service osm-ro stop
91 lxc exec $CONTAINER -- git -C /opt/openmano stash
92 lxc exec $CONTAINER -- git -C /opt/openmano pull --rebase
93 lxc exec $CONTAINER -- git -C /opt/openmano checkout $CHECKOUT_ID
94 lxc exec $CONTAINER -- git -C /opt/openmano stash pop
95 lxc exec $CONTAINER -- /opt/openmano/database_utils/migrate_mano_db.sh
96 lxc exec $CONTAINER -- service osm-ro start
97 fi
98 echo
99
100 echo -e " Updating SO and UI"
101 CONTAINER="SO-ub"
102 MDG="SO"
103 INSTALL_FOLDER="" # To be filled in
104 echo -e " Fetching the repo"
105 lxc exec $CONTAINER -- git -C $INSTALL_FOLDER fetch --all
106 BRANCH=""
107 BRANCH=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER status -sb | head -n1 | sed -n 's/^## \(.*\).*/\1/p'|awk '{print $1}' |sed 's/\(.*\)\.\.\..*/\1/'`
108 [ -z "$BRANCH" ] && FATAL "Could not find the current branch in use in the '$MDG'"
109 CURRENT=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER status |head -n1`
110 CURRENT_COMMIT_ID=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER rev-parse HEAD`
111 echo " FROM: $CURRENT ($CURRENT_COMMIT_ID)"
112 # COMMIT_ID either was previously set with -b option, or is an empty string
113 CHECKOUT_ID=$COMMIT_ID
114 [ -z "$CHECKOUT_ID" ] && [ "$BRANCH" == "HEAD" ] && CHECKOUT_ID="tags/$LATEST_STABLE_DEVOPS"
115 [ -z "$CHECKOUT_ID" ] && [ "$BRANCH" != "HEAD" ] && CHECKOUT_ID="$BRANCH"
116 if [[ $CHECKOUT_ID == "tags/"* ]]; then
117 REMOTE_COMMIT_ID=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER rev-list -n 1 $CHECKOUT_ID`
118 else
119 REMOTE_COMMIT_ID=`lxc exec $CONTAINER -- git -C $INSTALL_FOLDER rev-parse origin/$CHECKOUT_ID`
120 fi
121 echo " TO: $CHECKOUT_ID ($REMOTE_COMMIT_ID)"
122 if [ "$CURRENT_COMMIT_ID" == "$REMOTE_COMMIT_ID" ]; then
123 echo " Nothing to be done."
124 else
125 echo " Update required."
126 # Instructions to be added
127 # lxc exec SO-ub -- ...
128 fi
129 echo
130 }
131
132 function so_is_up(){
133 SO_IP=$1
134 time=0
135 step=5
136 timelength=300
137 while [ $time -le $timelength ]
138 do
139 curl -k https://$SO_IP:8008/api/operational/vcs/info \
140 --header 'accept: application/vnd.yang.data+json' \
141 --header 'authorization: Basic YWRtaW46YWRtaW4=' \
142 --header 'cache-control: no-cache' \
143 --header 'content-type: application/vnd.yang.data+json' &> /dev/null
144 RET=$?
145 if [ "$RET" == 0 ]; then
146 break
147 fi
148 sleep $step
149 echo -n "."
150 time=$((time+step))
151 done
152 if [ "$RET" != 0 ]; then
153 FATAL "OSM Failed to startup"
154 fi
155 echo
156 }
157
158 #Configure VCA, SO and RO with the initial configuration:
159 # RO -> tenant:osm, logs to be sent to SO
160 # VCA -> juju-password
161 # SO -> route to Juju Controller, add RO account, add VCA account
162 function configure(){
163 #Configure components
164 echo -e "\nConfiguring components"
165 . $OSM_DEVOPS/installers/export_ips
166
167 echo -e " Configuring RO"
168 lxc exec RO -- sed -i -e "s/^\#\?log_socket_host:.*/log_socket_host: $SO_CONTAINER_IP/g" /etc/osm/openmanod.cfg
169 lxc exec RO -- service osm-ro restart
170
171 time=0; step=2; timelength=20; while [ $time -le $timelength ]; do sleep $step; echo -n "."; time=$((time+step)); done; echo
172
173 lxc exec RO -- openmano tenant-delete -f osm >/dev/null
174 RO_TENANT_ID=`lxc exec RO -- openmano tenant-create osm |awk '{print $1}'`
175
176 echo -e " Configuring VCA"
177 JUJU_PASSWD=`date +%s | sha256sum | base64 | head -c 32`
178 echo -e "$JUJU_PASSWD\n$JUJU_PASSWD" | lxc exec VCA -- juju change-user-password
179 JUJU_CONTROLLER_IP=`lxc exec VCA -- lxc list -c 4 |grep eth0 |awk '{print $2}'`
180
181 echo -e " Configuring SO"
182 sudo route add -host $JUJU_CONTROLLER_IP gw $VCA_CONTAINER_IP
183 sudo sed -i "$ i route add -host $JUJU_CONTROLLER_IP gw $VCA_CONTAINER_IP" /etc/rc.local
184 lxc exec SO-ub -- systemctl restart launchpad
185
186 so_is_up $SO_CONTAINER_IP
187
188 #delete existing config agent (could be there on reconfigure)
189 curl -k --request DELETE \
190 --url https://$SO_CONTAINER_IP:8008/api/config/config-agent/account/osmjuju \
191 --header 'accept: application/vnd.yang.data+json' \
192 --header 'authorization: Basic YWRtaW46YWRtaW4=' \
193 --header 'cache-control: no-cache' \
194 --header 'content-type: application/vnd.yang.data+json' &> /dev/null
195
196 result=$(curl -k --request POST \
197 --url https://$SO_CONTAINER_IP:8008/api/config/config-agent \
198 --header 'accept: application/vnd.yang.data+json' \
199 --header 'authorization: Basic YWRtaW46YWRtaW4=' \
200 --header 'cache-control: no-cache' \
201 --header 'content-type: application/vnd.yang.data+json' \
202 --data '{"account": [ { "name": "osmjuju", "account-type": "juju", "juju": { "ip-address": "'$JUJU_CONTROLLER_IP'", "port": "17070", "user": "admin", "secret": "'$JUJU_PASSWD'" } } ]}')
203 [[ $result =~ .*success.* ]] || FATAL "Failed config-agent configuration: $result"
204
205 result=$(curl -k --request PUT \
206 --url https://$SO_CONTAINER_IP:8008/api/config/resource-orchestrator \
207 --header 'accept: application/vnd.yang.data+json' \
208 --header 'authorization: Basic YWRtaW46YWRtaW4=' \
209 --header 'cache-control: no-cache' \
210 --header 'content-type: application/vnd.yang.data+json' \
211 --data '{ "openmano": { "host": "'$RO_CONTAINER_IP'", "port": "9090", "tenant-id": "'$RO_TENANT_ID'" }, "name": "osmopenmano", "account-type": "openmano" }')
212 [[ $result =~ .*success.* ]] || FATAL "Failed resource-orchestrator configuration: $result"
213 }
214
215 function install_lxd() {
216 lxd init --auto
217 lxd waitready
218 systemctl stop lxd-bridge
219 systemctl --system daemon-reload
220 systemctl enable lxd-bridge
221 systemctl start lxd-bridge
222 }
223
224 function ask_user(){
225 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
226 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
227 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
228 read -e -p "$1" USER_CONFIRMATION
229 while true ; do
230 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
231 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
232 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
233 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
234 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
235 done
236 }
237
238 UNINSTALL=""
239 DEVELOP=""
240 NAT=""
241 UPDATE=""
242 RECONFIGURE=""
243 TEST_INSTALLER=""
244 LXD=""
245 SHOWOPTS=""
246 COMMIT_ID=""
247 ASSUME_YES=""
248 INSTALL_FROM_SOURCE=""
249
250 while getopts ":hy-:b:" o; do
251 case "${o}" in
252 h)
253 usage && exit 0
254 ;;
255 b)
256 COMMIT_ID=${OPTARG}
257 ;;
258 -)
259 [ "${OPTARG}" == "help" ] && usage && exit 0
260 [ "${OPTARG}" == "source" ] && INSTALL_FROM_SOURCE="y" && continue
261 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
262 [ "${OPTARG}" == "uninstall" ] && UNINSTALL="y" && continue
263 [ "${OPTARG}" == "nat" ] && NAT="y" && continue
264 [ "${OPTARG}" == "update" ] && UPDATE="y" && continue
265 [ "${OPTARG}" == "reconfigure" ] && RECONFIGURE="y" && continue
266 [ "${OPTARG}" == "test" ] && TEST_INSTALLER="y" && continue
267 [ "${OPTARG}" == "lxd" ] && LXD="y" && continue
268 [ "${OPTARG}" == "showopts" ] && SHOWOPTS="y" && continue
269 echo -e "Invalid option: '--$OPTARG'\n" >&2
270 usage && exit 1
271 ;;
272 \?)
273 echo -e "Invalid option: '-$OPTARG'\n" >&2
274 usage && exit 1
275 ;;
276 y)
277 ASSUME_YES="y"
278 ;;
279 *)
280 usage && exit 1
281 ;;
282 esac
283 done
284
285 if [ -n "$SHOWOPTS" ]; then
286 echo "DEVELOP=$DEVELOP"
287 echo "INSTALL_FROM_SOURCE=$INSTALL_FROM_SOURCE"
288 echo "UNINSTALL=$UNINSTALL"
289 echo "NAT=$NAT"
290 echo "UPDATE=$UPDATE"
291 echo "RECONFIGURE=$RECONFIGURE"
292 echo "TEST_INSTALLER=$TEST_INSTALLER"
293 echo "LXD=$LXD"
294 echo "SHOWOPTS=$SHOWOPTS"
295 echo "Install from specific refspec (-b): $COMMIT_ID"
296 exit 0
297 fi
298
299 # if develop, we force master
300 [ -z "$COMMIT_ID" ] && [ -n "$DEVELOP" ] && COMMIT_ID="master"
301
302 # if master, force install from source
303 [ -n "$COMMIT_ID" ] && [ "$COMMIT_ID" == "master" ] && INSTALL_FROM_SOURCE="y"
304
305 if [ -n "$TEST_INSTALLER" ]; then
306 echo -e "\nUsing local devops repo for OSM installation"
307 TEMPDIR="$(dirname $(realpath $(dirname $0)))"
308 else
309 echo -e "\nCreating temporary dir for OSM installation"
310 TEMPDIR="$(mktemp -d -q --tmpdir "installosm.XXXXXX")"
311 trap 'rm -rf "$TEMPDIR"' EXIT
312 fi
313
314 echo -e "Checking required packages: git"
315 dpkg -l git &>/dev/null || ! echo -e " git not installed.\nInstalling git requires root privileges" || sudo apt-get install -y git
316 if [ -z "$TEST_INSTALLER" ]; then
317 echo -e "\nCloning devops repo temporarily"
318 git clone https://osm.etsi.org/gerrit/osm/devops.git $TEMPDIR
319 RC_CLONE=$?
320 fi
321
322 echo -e "\nGuessing the current stable release"
323 LATEST_STABLE_DEVOPS=`git -C $TEMPDIR tag -l v[0-9].* | tail -n1`
324 [ -z "$COMMIT_ID" ] && [ -z "$LATEST_STABLE_DEVOPS" ] && echo "Could not find the current latest stable release" && exit 0
325 echo "Latest tag in devops repo: $LATEST_STABLE_DEVOPS"
326 [ -z "$COMMIT_ID" ] && [ -n "$LATEST_STABLE_DEVOPS" ] && COMMIT_ID="tags/$LATEST_STABLE_DEVOPS"
327 [ -z "$TEST_INSTALLER" ] && git -C $TEMPDIR checkout tags/$LATEST_STABLE_DEVOPS
328
329 OSM_DEVOPS=$TEMPDIR
330 OSM_JENKINS="$TEMPDIR/jenkins"
331 . $OSM_JENKINS/common/all_funcs
332
333 [ -n "$UNINSTALL" ] && uninstall && echo -e "\nDONE" && exit 0
334 [ -n "$NAT" ] && nat && echo -e "\nDONE" && exit 0
335 [ -n "$UPDATE" ] && update && echo -e "\nDONE" && exit 0
336 [ -n "$RECONFIGURE" ] && configure && echo -e "\nDONE" && exit 0
337
338 #Installation starts here
339 echo -e "\nInstalling OSM from refspec: $COMMIT_ID"
340 if [ -n "$INSTALL_FROM_SOURCE" ] && [ -z "$ASSUME_YES" ]; then
341 ! ask_user "The installation will take about 75-90 minutes. Continue (Y/n)? " y && echo "Cancelled!" && exit 1
342 fi
343
344 echo -e "\nChecking required packages: wget, curl, tar"
345 dpkg -l wget curl tar &>/dev/null || ! echo -e " One or several packages are not installed.\nInstalling required packages\n Root privileges are required" || sudo apt-get install -y wget curl tar
346
347 echo -e "Checking required packages: lxd"
348 lxd --version &>/dev/null || FATAL "lxd not present, exiting."
349 [ -n "$LXD" ] && echo -e "\nConfiguring lxd" && install_lxd
350
351 wget -q -O- https://osm-download.etsi.org/ftp/osm-2.0-two/README.txt &> /dev/null
352
353 if [ -z "$INSTALL_FROM_SOURCE" ]; then
354 echo -e "\nCreating the containers and installing from binaries ..."
355 $OSM_DEVOPS/jenkins/host/install RO || FATAL "RO install failed"
356 $OSM_DEVOPS/jenkins/host/start_build VCA || FATAL "VCA install failed"
357 $OSM_DEVOPS/jenkins/host/install SO || FATAL "SO install failed"
358 $OSM_DEVOPS/jenkins/host/install UI || FATAL "UI install failed"
359 else #install from source
360 echo -e "\nCreating the containers and building from source ..."
361 $OSM_DEVOPS/jenkins/host/start_build RO --notest checkout $COMMIT_ID || FATAL "RO container build failed (refspec: '$COMMIT_ID')"
362 $OSM_DEVOPS/jenkins/host/start_build VCA || FATAL "VCA container build failed"
363 $OSM_DEVOPS/jenkins/host/start_build SO checkout $COMMIT_ID || FATAL "SO container build failed (refspec: '$COMMIT_ID')"
364 $OSM_DEVOPS/jenkins/host/start_build UI checkout $COMMIT_ID || FATAL "UI container build failed (refspec: '$COMMIT_ID')"
365 fi
366
367 #Install iptables-persistent and configure NAT rules
368 nat
369
370 #Configure components
371 configure
372
373 wget -q -O- https://osm-download.etsi.org/ftp/osm-2.0-two/README2.txt &> /dev/null
374 echo -e "\nDONE"